program Test_ChrDPMI;
{
Description:
  RegisterBGIFont don't work in protected mode.

Reported by: John Leier [70711,3456]

Fix: None. Fixed in Graph clone unit.
}

uses
  graph;

procedure SmallFontProc; external;
{$L LITT.OBJ }

procedure TriplexFontProc; external;
{$L TRIP.OBJ }

var
  GrafDriver, GrafMode,GrafResult:Integer;

begin
  GrafDriver := Detect;
  GrafMode := 0;

  if RegisterBGIfont(@SmallFontProc) < 0 then halt;
  if RegisterBGIfont(@TriplexFontProc) < 0 then halt;

  initgraph(GrafDriver,GrafMode,'c:\bp\bgi');
  GrafResult:=GraphResult;
  if GrafResult = grOk then begin

    outtextxy(10,10,'Default Font');

    settextstyle(TriplexFont,HorizDir,4);
    outtextxy(10,50,'Triplex (first time)');

    settextstyle(SmallFont,HorizDir,7);
    outtextxy(10,90,'Small (first time)');

    settextstyle(TriplexFont,HorizDir,4);
    outtextxy(10,150,GraphErrorMsg(GraphResult));
    outtextxy(10,130,'Triplex (second time)');
    { in protected mode the linked font is not recognized it is reloaded
      is available in path else default font is used }

    readln;
    closegraph;
  end {if}
  else begin
    Writeln(GraphErrorMsg(GrafResult));
  end; {else}
end.
