program Test_FillPoly;
{
Description:
  The fillpattern may dont start or finish exactly at he outline.
  Sometimes pattern is drawn outside the outline or there is pattern missing
  near outline.

Reported by: Franck PISSOTTE [100117,200]

Fix: The bug is not located in graph unit or in bgi driver but comes from
     interaction of the two. i think a carefully written bgi driver should
     draw filled polygons correctly.
}

uses
  Graph;

var
  GrafDriver, GrafMode,GrafResult:Integer;
  x2,y2:Integer;
  Poly:array[1..5] of PointType;
begin
  GrafDriver := Detect;
  InitGraph(GrafDriver, GrafMode, 'c:\bp\bgi\');
  GrafResult:=GraphResult;
  if GrafResult = grOk then begin

    x2:=GetMaxX div 11;
    y2:=GetMaxY div 11;
    Poly[1].x:=x2-5;
    Poly[1].y:=y2+17;
    Poly[2].x:=x2*9+10;
    Poly[2].y:=y2+1;
    Poly[3].x:=x2*9-1;
    Poly[3].y:=y2*9+6;
    Poly[4].x:=x2-1;
    Poly[4].y:=y2*9;
    Poly[5]:=Poly[1];
    SetBkColor(Green);
    SetColor(Red);
    SetFillStyle(SolidFill,Yellow);
    FillPoly(5,Poly);

    Readln;
    CloseGraph;
  end {if}
  else begin
    Writeln(GraphErrorMsg(GrafResult));
  end; {else}
end.
