program Test_GrafMem;
{
Description:
  VESA16 allocate a 256 bytes buffer. (not documented)
  this buffer should be aligned on segment boundary (ie offset =0)
  in DPMI this buffer is not allocated via GrafGetMem.
  trident card require more than 256 bytes of buffer.

Reported by: Franck PISSOTTE [100117,200]
             Michael Day (TeamB) [70007,4645] (trident card)

Fix: BGI256 take care of trident card

}

uses
  Graph;

procedure Our_GrafGetMem(var Ptr:Pointer; Size:Word); far;
begin
  GetMem(Ptr,Size);
  writeln('Size=',Size);
  readln;
end; {Our_GrafGetMem}

procedure Our_GrafFreeMem(var Ptr:Pointer; Size:Word); far;
begin
  FreeMem(Ptr,Size);
  Ptr:=nil;
end; {Our_GrafFreeMem}

var
  GrafDriver, GrafMode,GrafResult:Integer;
  x2,y2:Integer;
begin
  GraphGetMemPtr  := @Our_GrafGetMem;
  GraphFreeMemPtr := @Our_GrafFreeMem;

  GrafDriver := InstallUserDriver('VESA16',nil);
  {GrafDriver:=Detect;}
  GrafMode:=1;
  InitGraph(GrafDriver, GrafMode, 'c:\bp\bgi\');
  GrafResult:=GraphResult;
  if GrafResult = grOk then begin

    OutTextXY(50,50,'Terminated');

    readln;
    CloseGraph;
  end {if}
  else begin
    Writeln(GraphErrorMsg(GrafResult));
  end; {else}
end.
