program Test_LineClip;
{
Description:
  clipped line are not drawn with the same pixel than unclipped one.

Reported by: Franck PISSOTTE [100117,200]

Fix: None. Difficult to fix. Clipping is done in graph unit, line drawing is
     done in the bgi driver.

}

uses
  Graph;

procedure Vector(A,B:PointType);
begin
  Line(A.x,A.y,B.x,B.y);
end; {Vector}

const
  c_Max_Lines=100;

var
  GrafDriver, GrafMode,GrafResult:Integer;
  Lines:array[1..c_Max_Lines] of record
    A,B:PointType;
  end;

  procedure InitLines;
  {-- create several lines }
  var
    i:Integer;
  begin
    for i:=1 to c_Max_Lines do begin
      Lines[i].A.X:=Random(GetMaxX);
      Lines[i].A.Y:=Random(GetMaxY);
      Lines[i].B.X:=Random(GetMaxX);
      Lines[i].B.Y:=Random(GetMaxY);
    end; {for}
  end; {InitLines}

  procedure DrawLines;
  {-- draw all the lines created }
  var
    i:Integer;
  begin
    for i:=1 to c_Max_Lines do begin
      Vector(Lines[i].A,Lines[i].B);
    end; {for}
  end; {DrawLines}

  procedure AdjustLines;
  {-- needed to adjust coordinate to draw lines at the same place after
      SetViewPort because it change origin }
  var
    i:Integer;
  begin
    for i:=1 to c_Max_Lines do begin
      dec(Lines[i].A.X,100);
      dec(Lines[i].A.Y,100);
      dec(Lines[i].B.X,100);
      dec(Lines[i].B.Y,100);
    end; {for}
  end; {AdjustLines}

begin
  GrafDriver := Detect;
  InitGraph(GrafDriver, GrafMode, 'c:\bp\bgi\');
  GrafResult:=GraphResult;
  if GrafResult = grOk then begin

    SetWriteMode(XorPut);
    InitLines;
    DrawLines;
    readln;

    SetViewPort(100,100,GetMaxX-100,GetMaxY-100,ClipOn);
    AdjustLines;

    DrawLines;

    Readln;
    CloseGraph;
  end {if}
  else begin
    Writeln(GraphErrorMsg(GrafResult));
  end; {else}
end.
