{$DEFINE VGA}

program Test_Register;
{
Description:
  Here is the minimal demo you requested.  Registering a driver not on
  a paragraph boundary locks up my machines.  This program deliberately
  loads the driver at an offset of 8 (which CAN be caused by the
  granularity of the heap manager.  Make sure the .BGI is in the current
  directory.  Versions have been tested for CGA, Hercules and VGA.  THE
  ERROR ONLY OCCURS WITH THE NEW 3.00 DRIVERS.  THE OLDER 2.00 BGI
  DRIVERS WILL FUNCTION PROPERLY ON THE 8 OFFSET!

Reported by: GARY WILTSHIRE [70523,3077]

Fix: allocate 8 bytes more, test offset if 8 set if to 0 and increment
     segment.
}

uses
  CRT,
  Graph;

type
  ADDRESS = record
              OFFSET,
              SEGMENT : word
            end;

var
  P, Q    : pointer;
  SIZE    : word;
  F       : file;

const

{$IFDEF CGA}
  DRIVER  : integer = CGA;
  MODE    : integer = CGAHI;
  NAME              = 'CGA.BGI';
{$ELSE} {$IFDEF EGA}
  DRIVER  : integer = EGA;
  MODE    : integer = EGAHI;
  NAME              = 'EGAVGA.BGI';
{$ELSE} {$IFDEF HERC}
  DRIVER  : integer = HercMono;
  MODE    : integer = HercMonoHi;
  NAME              = 'HERC.BGI';
{$ELSE}
  DRIVER  : integer = VGA;
  MODE    : integer = VGAHI;
  NAME              = 'EGAVGA.BGI';
{$ENDIF} {$ENDIF} {$ENDIF}

  procedure PAUSE;
  var
    C : char;
  begin
    C := ReadKey;
    if KeyPressed then C := ReadKey
  end;

  procedure TEST;
  begin
    RegisterBGIDriver(P);
    InitGraph(DRIVER, MODE, 'c:\bp\bgi');
    if GraphResult <> 0 then  {You won't get this far!}
      begin
        writeln('Graphics error.  Press any key.');
        PAUSE; halt(1)
      end;
    Ellipse(
      succ(GetMaxX div 2), succ(GetMaxY div 2),
      0, 360,
      pred(GetMaxX div 2), pred(GetMaxY div 2)
    );
    SetTextJustify(CenterText, CenterText);
    SetTextStyle(DefaultFont, HorizDir, 1);
    OutTextXY(
      GetMaxX div 2, GetMaxY div 2,
      'Graphics mode.  Press any key.'
    );
    PAUSE;
    CloseGraph;
    writeln('Text mode.  Press any key.');
    PAUSE
  end;

begin
  assign(F, NAME);
  reset(F, 1);
  SIZE := filesize(F);
  getmem(P, SIZE+8); Q := P;
  if ADDRESS(P).OFFSET = 0 then  {Deliberately forces an offset of 8.}
    inc(ADDRESS(P).OFFSET, 8);   {Changing "= 0" to "= 8" fixes bug.}
  blockread(F, P^, SIZE);
  close(F);
  TEST;
  TEST;
  freemem(Q, SIZE+8) {Deallocate original pointer}
end.
