program Test_SlowSector;
{
Description:
  sector with Xradius of 0 or 1 are drawn very slowly.

Reported by: Franck PISSOTTE [100117,200]

Fix: None. Fixed in Graph Clone unit.
}

uses
  crt,Graph;

var
  GrafDriver, GrafMode,GrafResult:Integer;
  x,y,rx,ry,mr,EndAngle,FillColor:Integer;
  Ch:Char;
begin
  GrafDriver := Detect;
  InitGraph(GrafDriver, GrafMode, 'c:\bp\bgi\');
  GrafResult:=GraphResult;
  if GrafResult = grOk then begin
    SetFillStyle(CloseDotFill,White);

    mr := GetMaxY div 10;
    SetLineStyle(SolidLn, 0, NormWidth);
    repeat
      EndAngle := Random(360);
      x:=Random(GetMaxX);
      y:=Random(GetMaxY);
      rx:=Random(mr);
      ry:=Random(mr);
      if (rx=0) or (rx=1) then begin
        FillColor:=Red;
      end {if}
      else begin
        FillColor:=LightGray;
      end; {else}
      SetColor(FillColor);
      SetFillStyle(Random(11)+1, FillColor);
      Sector(x, y, Random(EndAngle), EndAngle, rx, ry);
    until KeyPressed;
    Ch:=ReadKey;

    CloseGraph;
  end {if}
  else begin
    Writeln(GraphErrorMsg(GrafResult));
  end; {else}
end.
