program Test_XorPoly;
{
Description:
  in DrawPoly the first and last points of segments are drawn twice.

Reported by: Franck PISSOTTE [100117,200]

Fix: None.
}

uses
  Graph;

var
  GrafDriver, GrafMode,GrafResult:Integer;
  x2,y2,y:Integer;

  procedure Box(x1,y1,x2,y2:Integer);
  var
    Corners:array[1..5] of PointType;
  begin
    Corners[1].X:=x1;
    Corners[1].Y:=y1;
    Corners[2].X:=x2;
    Corners[2].Y:=y1;
    Corners[3].X:=x2;
    Corners[3].Y:=y2;
    Corners[4].X:=x1;
    Corners[4].Y:=y2;
    Corners[5]:=Corners[1];
    DrawPoly(5,Corners);
  end; {Box}

begin
  GrafDriver := Detect;
  InitGraph(GrafDriver, GrafMode, 'c:\bp\bgi\');
  GrafResult:=GraphResult;
  if GrafResult = grOk then begin
    SetWriteMode(XorPut);
    x2:=GetMaxX div 2-1;
    Y2:=GetMaxY div 2-1;
    for y:=1 to y2 do begin
      Box(X2-y,y2-y,x2+y,y2+y);
    end; {for}
    Readln;
    CloseGraph;
  end {if}
  else begin
    Writeln(GraphErrorMsg(GrafResult));
  end; {else}
end.
